package betterwithmods.client.container.bulk;

import betterwithmods.common.blocks.mechanical.tile.TileEntityMill;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.inventory.Container;
import net.minecraft.inventory.IContainerListener;
import net.minecraft.inventory.Slot;
import net.minecraft.item.ItemStack;
import net.minecraftforge.items.CapabilityItemHandler;
import net.minecraftforge.items.SlotItemHandler;

public class ContainerMill extends Container {
    private final TileEntityMill mill;
    private int lastMillCounter;
    public boolean blocked;

    public ContainerMill(EntityPlayer player, TileEntityMill mill) {
        this.mill = mill;

        for (int j = 0; j < 3; j++) {
            func_75146_a(new SlotItemHandler(mill.inventory, j, 62 + j * 18, 43));
        }

        for (int i = 0; i < 3; i++) {
            for (int j = 0; j < 9; j++) {
                func_75146_a(new SlotItemHandler(player.getCapability(CapabilityItemHandler.ITEM_HANDLER_CAPABILITY, null), j + i * 9 + 9, 8 + j * 18, 76 + i * 18));
            }
        }

        for (int i = 0; i < 9; i++) {
            func_75146_a(new SlotItemHandler(player.getCapability(CapabilityItemHandler.ITEM_HANDLER_CAPABILITY, null), i, 8 + i * 18, 134));
        }
    }

    @Override
    public boolean func_75145_c(EntityPlayer player) {
        return mill.isUseableByPlayer(player);
    }

    @Override
    public ItemStack func_82846_b(EntityPlayer player, int index) {
        ItemStack stack = ItemStack.field_190927_a;
        Slot slot = this.field_75151_b.get(index);

        if (slot != null && slot.func_75216_d()) {
            ItemStack stack1 = slot.func_75211_c();
            stack = stack1.func_77946_l();

            if (index < 3) {
                if (!func_75135_a(stack1, 3, this.field_75151_b.size(), true))
                    return ItemStack.field_190927_a;
            } else if (!func_75135_a(stack1, 0, 3, false))
                return ItemStack.field_190927_a;
            if (stack1.func_190916_E() == 0)
                slot.func_75215_d(ItemStack.field_190927_a);
            else
                slot.func_75218_e();
        }
        return stack;
    }

    @Override
    public void func_75132_a(IContainerListener listener) {
        super.func_75132_a(listener);
        listener.func_71112_a(this, 0, this.mill.grindCounter);
        listener.func_71112_a(this, 1, this.mill.blocked ? 0 : 1);
    }

    @Override
    public void func_75142_b() {
        super.func_75142_b();
        for (IContainerListener craft : this.field_75149_d) {
            if (this.lastMillCounter != this.mill.grindCounter) {
                craft.func_71112_a(this, 0, this.mill.grindCounter);
            }
            craft.func_71112_a(this, 1, this.mill.blocked ? 1 : 0);
        }
        this.lastMillCounter = this.mill.grindCounter;
        this.blocked = this.mill.blocked;
    }

    @Override
    public void func_75137_b(int index, int value) {
        switch (index) {
            case 0:
                this.mill.grindCounter = value;
                break;
            case 1:
                blocked = value == 1;
                break;
        }
    }
}
