package betterwithmods.common.potion;

import net.minecraft.block.state.IBlockState;
import net.minecraft.client.Minecraft;
import net.minecraft.entity.EntityLivingBase;
import net.minecraft.init.Blocks;
import net.minecraft.util.EnumFacing;
import net.minecraft.util.EnumParticleTypes;
import net.minecraft.util.math.BlockPos;
import net.minecraft.util.math.MathHelper;
import net.minecraft.world.EnumSkyBlock;
import net.minecraft.world.World;

public class PotionTruesight extends BWPotion {
    public PotionTruesight(String name, boolean b, int potionColor) {
        super(name, b, potionColor);
    }

    @Override
    public void tick(EntityLivingBase entity) {
        World world = entity.func_130014_f_();
        if (world.field_72995_K) {
            Minecraft mc = Minecraft.func_71410_x();
            int var3 = mc.field_71474_y.field_74362_aa;
            if (!mc.func_147113_T()
                    && (world.field_73011_w.getDimension() == 0 || world.field_73011_w.getDimension() == 1)) {

                int var4 = MathHelper.func_76128_c(entity.field_70165_t);
                int var5 = MathHelper.func_76128_c(entity.field_70163_u);
                int var6 = MathHelper.func_76128_c(entity.field_70161_v);
                int radius = 10;
                for (int x = var4 - radius; x <= var4 + radius; ++x) {
                    for (int y = var5 - radius; y <= var5 + radius; ++y) {
                        for (int z = var6 - radius; z <= var6 + radius; ++z) {
                            if (canMobsSpawnHere(world, new BlockPos(x, y, z))
                                    && (var3 == 0 || world.field_73012_v.nextInt(12) <= 2 - var3 << 1)) {

                                double i = (double) x + world.field_73012_v.nextDouble();
                                double j = (double) y + world.field_73012_v.nextDouble() * 0.25D;
                                double k = (double) z + world.field_73012_v.nextDouble();
                                world.func_175688_a(EnumParticleTypes.SPELL_MOB, i, j, k, 0, 0, 0);
                            }
                        }
                    }
                }
            }
        }

    }

    public static boolean canMobsSpawnHere(World world, BlockPos pos) {
        if (!world.isSideSolid(pos.func_177977_b(), EnumFacing.UP)) {
            return false;
        } else if (!world.func_175677_d(pos, false) && !world.func_175677_d(pos.func_177984_a(), false)
                && !world.func_180495_p(pos).func_185904_a().func_76224_d()) {
            IBlockState state = world.func_180495_p(pos);
            if (state == Blocks.field_150357_h.func_176223_P()) {
                return false;
            } else if (world.func_72820_D() < 11615 && world.func_175642_b(EnumSkyBlock.SKY, pos) >= 15) {
                return false;
            } else {
                int lightLevel = world.func_175642_b(EnumSkyBlock.BLOCK, pos);
                return lightLevel < 8 && (world.func_175623_d(pos) || state.func_185890_d(world, pos) == null);
            }
        } else {
            return false;
        }

    }
}
